=== modified file 'lib/lp/soyuz/adapters/notification.py'
--- lib/lp/soyuz/adapters/notification.py	2011-07-29 09:18:07 +0000
+++ lib/lp/soyuz/adapters/notification.py	2011-07-29 15:17:22 +0000
@@ -279,7 +279,12 @@
         'USERS_ADDRESS': config.launchpad.users_address,
         }
     if spr:
-        information['SPR_URL'] = canonical_url(spr)
+        # Yay, circular imports.
+        from lp.soyuz.model.distroseriessourcepackagerelease import (
+            DistroSeriesSourcePackageRelease,
+            )
+        dsspr = DistroSeriesSourcePackageRelease(distroseries, spr)
+        information['SPR_URL'] = canonical_url(dsspr)
     changedby_displayname = info['changedby_displayname']
     if changedby_displayname:
         information['CHANGEDBY'] = '\nChanged-By: %s' % changedby_displayname

=== modified file 'lib/lp/soyuz/adapters/tests/test_notification.py'
--- lib/lp/soyuz/adapters/tests/test_notification.py	2011-07-29 09:18:07 +0000
+++ lib/lp/soyuz/adapters/tests/test_notification.py	2011-07-29 15:17:22 +0000
@@ -10,6 +10,7 @@
 from zope.component import getUtility
 from zope.security.proxy import removeSecurityProxy
 
+from canonical.launchpad.webapp.publisher import canonical_url
 from canonical.testing.layers import (
     LaunchpadZopelessLayer,
     ZopelessDatabaseLayer,
@@ -34,6 +35,9 @@
     ArchivePurpose,
     PackageUploadCustomFormat,
     )
+from lp.soyuz.model.distroseriessourcepackagerelease import (
+    DistroSeriesSourcePackageRelease,
+    )
 from lp.testing import TestCaseWithFactory
 from lp.testing.mail_helpers import pop_notifications
 
@@ -334,6 +338,20 @@
                              None, "unapproved")
         self.assertIn("Waiting for approval", body)
 
+    def test_assemble_body_inserts_package_url_for_distro_upload(self):
+        # The email body should contain the canonical url to the package
+        # page in the target distroseries.
+        spr = self.factory.makeSourcePackageRelease()
+        blamer = self.factory.makePerson()
+        archive = self.factory.makeArchive(purpose=ArchivePurpose.PRIMARY)
+        series = self.factory.makeDistroSeries()
+
+        body = assemble_body(blamer, spr, [], archive, series, "",
+                             None, "unapproved")
+        dsspr = DistroSeriesSourcePackageRelease(series, spr)
+        url = canonical_url(dsspr)
+        self.assertIn(url, body)
+
     def test__is_auto_sync_upload__no_preferred_email_for_changer(self):
         # If changer has no preferred email address,
         # is_auto_sync_upload should still work.

=== modified file 'lib/lp/soyuz/scripts/tests/test_copypackage.py'
--- lib/lp/soyuz/scripts/tests/test_copypackage.py	2011-07-25 13:52:30 +0000
+++ lib/lp/soyuz/scripts/tests/test_copypackage.py	2011-07-30 14:18:20 +0000
@@ -1461,7 +1461,7 @@
 
             Date: %s
             Changed-By: Foo Bar <foo.bar@canonical.com>
-            http://launchpad.dev/ubuntutest/breezy-autotest/+source/foo/1.0-2
+            http://launchpad.dev/ubuntutest/nobby/+source/foo/1.0-2
             """ % source.sourcepackagerelease.dateuploaded)
         self.assertIn(expected_text, notification.as_string())
         self.assertIn(expected_text, announcement.as_string())

